%define SRC_VERSION	2.96
%define STDC_VERSION	2.10.0
%define LIBSTDCXX_V3	0
%define SNAPSHOT	20000731
%define compat_verrel 2.96-ipl17mdk
%define gcc_branch 2.96
%define priority 20

%def_with objc
%def_without java
%def_with check

Name: gcc%gcc_branch
Version: 2.96
Release: alt6

Summary: The GNU Compiler Collection
License: GPL
Group: Development/C
Url: http://gcc.gnu.org/
Packager: GCC Development Team <gcc@packages.altlinux.org>

%define os_release %distribution, build %version-%release
%define psuffix -%version
%define gcc_target_dir %_libdir/gcc-lib/%_target_platform/%version
%define gcc_doc_dir %_docdir/gcc-%version

Source: ftp://ftp.gnu.org/pub/gnu/gcc/gcc-%SRC_VERSION-%SNAPSHOT.tar.bz2
Source2: gcc-cpp-20010126.tar.bz2
Source3: gcc-consistency-test.tar.bz2

# RH
Patch2: gcc-new-abi.patch
Patch4: gcc-c++-typedef.patch
Patch5: gcc-no-warn-trigraphs.patch
Patch6: gcc-incomplete-struct.patch
Patch8: gcc-libstdc++-v3-wnoerror.patch
Patch9: gcc-string-crash.patch
Patch10: gcc-sparc64-subreg-byte.patch
Patch11: gcc-sparc64-reload.patch
Patch12: gcc-sparc64-startfile.patch
Patch13: gcc-sparc64-decloffset.patch
Patch14: gcc-sparc64-uname.patch
Patch15: gcc-sparc32-vaarg.patch
Patch16: gcc-sparc64-hwint.patch
Patch18: gcc-java-jword.patch
Patch19: gcc-align-memcpy.patch
Patch20: gcc-sparcv9-hack.patch
Patch21: gcc-stmtexpr.patch
Patch22: gcc-sparc32-hack.patch
Patch23: gcc-sparc32-hack2.patch
Patch25: gcc-clear-hack.patch
Patch28: gcc-loop.patch
Patch29: gcc-alpha-addressof.patch
Patch31: gcc-regmove-asm.patch
Patch33: gcc-cpplib.patch
Patch35: gcc-cpp0.patch
Patch36: gcc-canon-cond.patch
Patch37: gcc-bogus-subreg.patch
Patch38: gcc-cp-ii.patch
Patch39: gcc-subreg-gcse.patch
Patch40: gcc-subregbyte-gcse.patch
Patch41: gcc-combine-comparison.patch
Patch42: gcc-loop-noopt.patch
Patch43: gcc-loop-unroll.patch
Patch44: gcc-loop-test1.patch
Patch45: gcc-loop-test2.patch
Patch46: gcc-loop-scanloop.patch
Patch48: gcc-i386-ashlsilea.patch
Patch49: gcc-i386-lea.patch
Patch50: gcc-lowpart-test.patch
Patch51: gcc-loop-noopt2.patch
Patch52: gcc-i386-sibcall.patch
Patch53: gcc-cpp-warn.patch
Patch54: gcc-wint_t.patch
Patch55: gcc-format-checking.patch
Patch56: gcc-strftime.patch
Patch57: gcc-xopen.patch
Patch58: gcc-c99.patch
Patch59: gcc-iso-not-ansi.patch
Patch60: gcc-sibcall.patch
Patch61: gcc-Os-testcase.patch
Patch62: gcc-java-misc.patch
Patch63: gcc-java-bytecode.patch
Patch64: gcc-java-pg.patch
Patch65: gcc-commutative.patch
Patch66: gcc-relational.patch
Patch67: gcc-f-include.patch
Patch68: gcc-unroll.patch
Patch69: gcc-i386-strops.patch
Patch70: gcc-simplify-relational.patch
Patch71: gcc-alias.patch
Patch72: gcc-jsm1.patch
Patch73: gcc-jsm2.patch
Patch74: gcc-jsm3.patch
Patch75: gcc-scanf.patch
Patch76: gcc-jsm4.patch
Patch77: gcc-jsm5.patch
Patch78: gcc-jsm6.patch
Patch79: gcc-jsm7.patch
Patch80: gcc-jsm8.patch
Patch81: gcc-loop-hack.patch
Patch82: gcc-cpp-warnpaste.patch
Patch83: gcc-float-condmove.patch
Patch84: gcc-i386-call.patch
Patch85: gcc-i386-call2.patch
Patch86: gcc-i386-call-test.patch
Patch87: gcc-i386-arith.patch
Patch88: gcc-i386-ge_geu.patch
Patch89: gcc-i386-gotoff.patch
Patch90: gcc-java-catchup.patch
Patch91: gcc-java-no-super-layout.patch
Patch92: gcc-make-extraction.patch
Patch93: gcc-segv1.patch
Patch94: gcc-segv2.patch
Patch95: gcc-sparc-copy-leaf-remappable.patch
Patch96: gcc-wchar-const.patch
Patch97: gcc-libio.patch
Patch98: gcc-alpha-tune.patch
Patch99: gcc-alpha-unaligned.patch
Patch100: gcc-cpp-warnpaste2.patch
Patch101: gcc-loop-giv.patch
Patch102: gcc-real-value.patch
Patch103: gcc-sparc-const-pool.patch
Patch104: gcc-sparc64-timode.patch
Patch105: gcc-callersave-segv.patch
Patch106: gcc-libio-printf_fp.patch
Patch107: gcc-pt-enum.patch
Patch108: gcc-sparc-pic.patch
Patch109: gcc-subreg-byte-expmed.patch
Patch110: gcc-test-991206-1.patch
Patch111: gcc-alpha-mi-thunk.patch
Patch112: gcc-c++-pmf.patch
Patch113: gcc-f77-fdebug.patch
Patch114: gcc-libio-endl.patch
Patch115: gcc-i386-compare-test.patch
Patch116: gcc-sparc-may-trap.patch
Patch117: gcc-sparc-mi-thunk.patch
Patch118: gcc-c++-inline16-test.patch
Patch119: gcc-c++-named-return-value.patch
Patch120: gcc-c++-walk-tree.patch
Patch121: gcc-i386-reload-test.patch
Patch122: gcc-i386-reload.patch
Patch123: gcc-sibcall-unchanging.patch
Patch124: gcc-segv3.patch
Patch125: gcc-c++-crash24.patch
Patch126: gcc-do-store-flag.patch
Patch127: gcc-i386-address-cost.patch
Patch128: gcc-i386-arith2.patch
Patch129: gcc-i386-constraint-N.patch
Patch130: gcc-incomplete-aggregate-alias.patch
Patch131: gcc-sibcall-eh2.patch
Patch132: gcc-cpp-assert-crash.patch
Patch133: gcc-c++-undefined-method.patch
Patch134: gcc-sparc-4096.patch
Patch135: gcc-sparc64-reload-test.patch
Patch136: gcc-sparc64-reload2.patch
Patch137: gcc-subreg-byte-operand-subword.patch
Patch139: gcc-c++-static-class.patch
Patch140: gcc-c++-testset1.patch
Patch141: gcc-c++-testset2.patch
Patch142: gcc-place-field.patch
Patch143: gcc-sparc-output-formatting.patch
Patch144: gcc-sparc64-mi-thunk.patch
Patch145: gcc-sparc64-namedret.patch
Patch146: gcc-sparc64-nested-fn.patch
Patch147: gcc-c++-ice.patch
Patch148: gcc-alpha-fold-const.patch
Patch149: gcc-alpha-recog.patch
Patch150: gcc-c++-pointer-to-member-test.patch
Patch151: gcc-c++-sizetype.patch
Patch152: gcc-cpp-64k.patch
Patch153: gcc-cpp-empty-header.patch
Patch154: gcc-i386-regelim.patch
Patch155: gcc-sparc-builtin-setjmp.patch
Patch156: gcc-test-loop-7.patch
Patch157: gcc-c++-dump-expr.patch
Patch158: gcc-c++-inline-cmp.patch
Patch159: gcc-c++-inline-return.patch
Patch160: gcc-c++-label-scope.patch
Patch161: gcc-c++-ptm.patch
Patch162: gcc-c++-qual-error.patch
Patch163: gcc-const-fold.patch
Patch164: gcc-cpp-error-directive.patch
Patch165: gcc-i386-truncxfsf.patch
Patch166: gcc-integrate-clobber.patch
Patch167: gcc-libf2c-mkstemp.patch
Patch168: gcc-local-alloc.patch
Patch169: gcc-loop-hoistmem.patch
Patch170: gcc-sibcall-const.patch
Patch171: gcc-sibcall-emit-queue.patch
Patch172: gcc-unroll-iterations.patch
Patch173: gcc-volatile-local-var.patch
Patch174: gcc-c++-sizetype2.patch
Patch175: gcc-error-diagnostic.patch
Patch176: gcc-aggregate-mode.patch
Patch177: gcc-c++-addressof.patch
Patch178: gcc-aggregate-mode2.patch
Patch179: gcc-c++-addressof2.patch
Patch180: gcc-c++-inline-cmp2.patch
Patch181: gcc-cpp-fno-operator-names.patch
Patch182: gcc-c++-ggc-input.patch
Patch183: gcc-alpha-unaligned2.patch
Patch184: gcc-alpha-ze_and_ne.patch
Patch185: gcc-c++-wchar_t.patch
Patch186: gcc-cpp-arg-loop.patch
Patch187: gcc-cpp-fno-operator-names2.patch
Patch188: gcc-cpp-g3.patch
Patch189: gcc-fshort-wchar.patch
Patch190: gcc-max-strlen.patch
Patch191: gcc-stabs.patch
Patch192: gcc-subreg-byte-gcse2.patch
Patch193: gcc-tradcpp-MD.patch
Patch194: gcc-alpha-expand-block-move.patch
Patch195: gcc-c++-decl-needed.patch
Patch196: gcc-c++-nomods_initdcl0.patch
Patch197: gcc-cpp-MD.patch
Patch198: gcc-fixup-var-refs.patch
Patch199: gcc-frame-related.patch
Patch200: gcc-i386-cmpqi.patch
Patch201: gcc-i386-const-call-address.patch
Patch202: gcc-i386-fcmov.patch
Patch203: gcc-i386-sar.patch
Patch204: gcc-c++-extern-c.patch
Patch205: gcc-c++-inline-static.patch
Patch206: gcc-c++-inline-static2.patch
Patch207: gcc-cpp-M-include.patch
Patch208: gcc-integrate-compare.patch
Patch209: gcc-cpp-20010126.patch
Patch210: gcc-objc-cpp-lineno.patch
Patch211: gcc-cpp-paste-avoid.patch
Patch212: gcc-cpp-paste-avoid2.patch
Patch213: gcc-c++-inline-modify_expr.patch
Patch214: gcc-i386-testqi_1.patch
Patch215: gcc-c++-anon-union.patch
Patch216: gcc-extract_bit_field.patch
Patch217: gcc-c++-overload-warn.patch
Patch218: gcc-cpp-implicit-extern-c.patch
Patch219: gcc-cpp-paste-avoid3.patch
Patch220: gcc-packed-enum-bitfield.patch
Patch221: gcc-variable-size.patch

# ia64 jumbo patch
Patch222: gcc-ia64.patch.bz2
Patch223: gcc-ia64-errata.patch

Patch224: gcc-cpp-defined-diag.patch
Patch225: gcc-cpp-paste-avoid4.patch
Patch226: gcc-dwarf2out-ice.patch
Patch227: gcc-g++.jason-2371.patch
Patch228: gcc-lex-line.patch
Patch229: gcc-alpha-unaligned3.patch
Patch230: gcc-consistency-test.patch
Patch231: gcc-nested-parm.patch
Patch232: gcc-alpha-reload.patch
Patch233: gcc-alpha-shift.patch
Patch234: gcc-c++-init-copy-aggr.patch
Patch235: gcc-c++-inline-loop.patch
Patch236: gcc-c++-lookup.patch
Patch237: gcc-c++-taking-address-error.patch
Patch238: gcc-objc-gc.patch
Patch239: gcc-objc-test.patch
Patch240: gcc-reload-hardreg-free.patch
Patch241: gcc-cpp-20010222.patch
Patch242: gcc-expr-safety.patch
Patch243: gcc-debug-static-local.patch
Patch244: gcc-fixup-var-refs2.patch
Patch245: gcc-fold-const-div.patch
Patch246: gcc-g77-unused.patch
Patch247: gcc-ia64-flushrs.patch
Patch248: gcc-ia64-syscall-linkage.patch
Patch249: gcc-recog-addressof.patch
Patch250: gcc-cpp-20010309.patch
Patch251: gcc-cant-combine.patch
Patch252: gcc-i386-crtendS.patch
Patch253: gcc-reg-stack-clobber.patch
Patch254: gcc-reg-stack.patch
Patch255: gcc-store-expr.patch
Patch256: gcc-target-expr.patch
Patch257: gcc-c++-anonaggr-copy.patch
Patch258: gcc-c++-asmspec.patch
Patch259: gcc-c++-static-local.patch
Patch260: gcc-f77-line.patch
Patch261: gcc-libstdc++-getline.patch
Patch262: gcc-no-new-abi.patch
Patch263: gcc-regrename.patch
Patch264: gcc-subreg-byte-gcse3.patch
Patch265: gcc-wshadow-doc.patch
Patch266: gcc-c++-D__EXCEPTIONS.patch
Patch267: gcc-c++-throttle-inline.patch
Patch268: gcc-fold-pointer-cmp.patch
Patch269: gcc-ifcvt-strict-low-part.patch
Patch270: gcc-gcse-reg-equiv.patch
Patch271: gcc-null-pointer-check.patch
Patch272: gcc-local-inline.patch
Patch273: gcc-cpp-Wcomment.patch
Patch274: gcc-cselib-mode.patch
Patch275: gcc-dwarf2-O0-crash.patch
Patch276: gcc-dwarf2out-splice-child.patch
Patch277: gcc-i386-movcc.patch
Patch278: gcc-ia64-xdata.patch
Patch279: gcc-subregbyte-hard-regno.patch
Patch280: gcc-tradtradcpp0.patch
Patch281: gcc-flow-autoinc.patch
Patch282: gcc-ia64-constconst.patch
Patch283: gcc-ia64-G.patch
Patch284: gcc-integrate-error.patch
Patch285: gcc-MD-nodot.patch
Patch286: gcc-store-constructor-field.patch
Patch287: gcc-ia64-except.patch
Patch288: gcc-ia64-loc79.patch
Patch289: gcc-ia64-bstep.patch
Patch290: gcc-c++-templ-arg.patch
Patch291: gcc-frame-state-for-compat.patch
Patch292: gcc-sibcall-catch.patch
Patch293: gcc-tradcpp-define.patch
Patch294: gcc-c++-inline-method.patch
Patch295: gcc-gcse-trapping.patch
Patch296: gcc-nested-expr-stmt.patch
Patch297: gcc-__NO_INLINE__.patch
Patch298: gcc-bogus-inline.patch
Patch299: gcc-c++-defarg.patch
Patch300: gcc-c++-instantiate.patch
Patch301: gcc-c++-static-ctordtor.patch
Patch302: gcc-c++-templ-arg2.patch
Patch303: gcc-c++-ucs.patch
Patch304: gcc-fsyntax-only.patch
Patch305: gcc-g77-unsigned-char.patch
Patch306: gcc-hash-ident.patch
Patch307: gcc-jump-threading.patch
Patch308: gcc-regmove-unchanging.patch
Patch309: gcc-ia64-complex-float.patch
Patch310: gcc-ia64-movcc-fail.patch
Patch311: gcc-ia64-stop-bit.patch
Patch312: gcc-c++-friend.patch
Patch313: gcc-i386-stack-adjust.patch
Patch314: gcc-SHF_MERGE.patch
Patch315: gcc-dwarf2-filenames.patch
Patch316: gcc-k6-loop.patch
Patch317: gcc-libobjc-3.0.patch
Patch318: gcc-texinfo-texconfig.patch
Patch319: gcc-c++-complext.patch
Patch320: gcc-c++-conv-cv-ptr.patch
Patch321: gcc-c++-sstream-warn.patch
Patch322: gcc-f77-ffixed.patch
Patch323: gcc-invalid-stabs.patch
Patch324: gcc-libio-test.patch
Patch325: gcc-alpha-function-sections.patch
Patch326: gcc-alpha-vtable-gc.patch
Patch327: gcc-c++-anontypename.patch
Patch328: gcc-c++-array-cast.patch
Patch329: gcc-c++-colonequal.patch
Patch330: gcc-c++-cond-ovl.patch
Patch331: gcc-c++-weak-address.patch
Patch332: gcc-libio-input-float.patch
Patch333: gcc-subreg-byte-stabs.patch
Patch334: gcc-c++-array-side-effects.patch
Patch335: gcc-cpp-memleak.patch
Patch336: gcc-c++-template-throw.patch
Patch337: gcc-c++-tsubst-friend-class.patch
Patch338: gcc-dwarf2-debug-line.patch
Patch339: gcc-ifcvt-eh.patch
Patch340: gcc-ia64-vararg.patch
Patch341: gcc-gcse-hoist.patch
Patch342: gcc-ia64-eh.patch
Patch343: gcc-libio-stdstream-offset.patch
Patch344: gcc-objc-class-ref.patch
Patch345: gcc-tail-recurse.patch
Patch346: gcc-c++-sstream-seek.patch
Patch347: gcc-loop-combine-givs.patch
Patch348: gcc-alpha-asm-input.patch
Patch349: gcc-c++-anon-union2.patch
Patch350: gcc-c++-inline-sizeof-char.patch
Patch351: gcc-cpp-run-directive.patch
Patch352: gcc-reload-optional.patch
Patch353: gcc-fde-merge-compat.patch
Patch354: gcc-flow-setjmp.patch
Patch355: gcc-pure-reload.patch
Patch356: gcc-sparc-float.patch
Patch357: gcc-sparc-movdf.patch
Patch358: gcc-c++-member-init.patch
Patch359: gcc-autoconf-2.52.patch
Patch360: gcc-makej.patch
Patch361: gcc-ia64-bitfield-return.patch
Patch362: gcc-ia64-NaT.patch
Patch363: gcc-sparc-libcall.patch
Patch364: gcc-c++-preexpand-calls.patch
Patch365: gcc-libio-stdstreams-vptr.patch
Patch366: gcc-sparc-return.patch
Patch367: gcc-sparc64-nonzero-bits.patch
Patch368: gcc-below-sp.patch
Patch369: gcc-c++-setup-vtbl-ptr.patch
Patch370: gcc-reload-ofp.patch
Patch371: gcc-bitop-shorten.patch
Patch372: gcc-c++-ptrintsum.patch
Patch373: gcc-i386-fxch.patch
Patch374: gcc-i386-regparm-struct.patch
Patch375: gcc-ia64-encode-section-info.patch
Patch376: gcc-attr-visibility.patch
Patch377: gcc-store_field-expand_and.patch
Patch378: gcc-c++-array-ref.patch
Patch379: gcc-c++-flat-initializer.patch
Patch380: gcc-c++-static-member.patch
Patch381: gcc-i386-reg-stack-check.patch
Patch382: gcc-i386-zero-size.patch
Patch383: gcc-loop-check_dbra_loop.patch
Patch384: gcc-pedwarn-string-length.patch
Patch385: gcc-simplify-check-overflow.patch
Patch386: gcc-UDA-option-order.patch
Patch387: gcc-c++-pt-using.patch
Patch388: gcc-c++-pt-using2.patch
Patch389: gcc-attr-visibility2.patch
Patch390: gcc-libstdc++-libc-interface.patch
Patch391: gcc-attr-visibility3.patch
Patch392: gcc-ia64-thread-safe-eh.patch
Patch393: gcc-merge_blocks_nomove.patch
Patch394: gcc-attr-visibility4.patch
Patch395: gcc-unaligned-const.patch
Patch396: gcc-i386-piclabel.patch
Patch397: gcc-2.96-parallel.patch
Patch398: gcc-i386-andhi.patch
Patch399: gcc-mem-scratch.patch
Patch400: gcc-unroll2.patch
Patch401: gcc-sparc-tfdi.patch
Patch402: gcc-c++-gc-named-label-list.patch
Patch403: gcc-cpp-include-dir.patch
Patch404: gcc-c++-compound-literal.patch
Patch405: gcc-c++-eh-spec-incomplete.patch
Patch406: gcc-fde-merge-compat-2.patch
Patch407: gcc-strict-alias-optimization.patch
Patch408: gcc-cpp-MD-2.patch

# Debian
Patch900: gcc-2.95.3-alpha-spec.patch

# ALT
Patch1000: gcc-2.95.2-install.patch
Patch1001: gcc-2.95.2-fixbuild.patch
Patch1002: gcc-2.96-assert.patch
Patch1003: gcc-2.96-man.patch
Patch1004: gcc-2.96-texinfo.patch
Patch1005: gcc-2.96-nowrap.patch
Patch1006: gcc-alt-parser_namespace_fixes.patch

Provides: gcc = %compat_verrel, %_bindir/%_target_platform-gcc, %_bindir/gcc
Obsoletes: egcs, gcc = %version
PreReq: alternatives >= 0.0.6, gcc-common >= 1.4
Requires: cpp%gcc_branch = %version-%release, %{get_dep binutils}, glibc-devel, make >= 3.79.1

BuildPreReq: rpm-build >= 4.0.4-alt0.7, make >= 3.79.1, binutils >= 2.11.90.0.31
BuildPreReq: libalternatives-devel

%description
This package contains the GNU Compiler Collection (GCC). You'll need
this package in order to compile C/C++ code.

%package -n cpp%gcc_branch
Summary: The C Preprocessor
Group: Development/C
Provides: cpp = %compat_verrel, gcc-cpp, %_bindir/cpp
Obsoletes: gcc-cpp, egcs-cpp, cpp = %version
PreReq: alternatives >= 0.0.6, gcc-common >= 1.4

%description -n cpp%gcc_branch
Cpp is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, which are abbreviations for longer constructs.

The C preprocessor provides four separate facilities that you can use
as you see fit:
+ Inclusion of header files. These are files of declarations that can be
  substituted into your program.
+ Macro expansion. You can define 'macros,' which are abbreviations for
  arbitrary fragments of C code, and then the C preprocessor will replace
  the macros with their definitions throughout the program.
+ Conditional compilation. Using special preprocessing directives,
  you can include or exclude parts of the program according to various
  conditions.
+ Line control. If you use a program to combine or rearrange source files
  into an intermediate file which is then compiled, you can use line
  control to inform the compiler about where each source line originated.

You should install this package if you are a programmer who is searching for
such a macro processor.

%package -n libstdc++%gcc_branch
Summary: GNU C++ library
Group: System/Libraries
Provides: libstdc++-libc6.1-1.so.2, libstdc++-libc6.1-1.1.so.2, libstdc++-libc6.1-2.so.2
Provides: libstdc++-libc6.1-2.so.3, libstdc++-3-libc6.1-2-%STDC_VERSION.so
Provides: libstdc++-libc6.2-2.so.3, libstdc++.so.2.9
Provides: libstdc++ = %compat_verrel
Obsoletes: gcc-libstdc++, libg++, libstdc++ = %version
PreReq: alternatives >= 0.0.6, gcc-c++-common >= 1.4
Conflicts: glibc < 2.1.92
BuildPreReq: glibc >= 2.1.92

%description -n libstdc++%gcc_branch
This is the GNU implementation of the standard C++ libraries This package
includes the shared libraries necessary to run C++ applications.

%package -n libstdc++%gcc_branch-devel
Summary: Header files and libraries for C++ development
Group: Development/C++
Provides: %_libdir/libstdc++.so, libstdc++-devel = %compat_verrel
Obsoletes: gcc-libstdc++-devel, libg++-devel, libstdc++-devel = %version
PreReq: alternatives >= 0.0.6, gcc-c++-common >= 1.4
Requires: libstdc++%gcc_branch = %version-%release
Conflicts: glibc < 2.1.92
BuildPreReq: glibc >= 2.1.92

%description -n libstdc++%gcc_branch-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development. This includes SGI's implementation of the STL.

%package -n libstdc++%gcc_branch-devel-static
Summary: Static libraries for C++ development
Group: Development/C++
Provides: %_libdir/libstdc++.a, libstdc++-devel-static = %compat_verrel
PreReq: gcc-c++-common >= 1.4
Requires: libstdc++%gcc_branch-devel = %version-%release
Conflicts: glibc < 2.1.92
BuildPreReq: glibc >= 2.1.92

%description -n libstdc++%gcc_branch-devel-static
This is the GNU implementation of the standard C++ libraries.
This package includes static libraries needed for C++ development.

%package c++
Summary: C++ support for gcc
Group: Development/C++
Provides: gcc-c++ = %compat_verrel, %_bindir/%_target_platform-g++, %_bindir/g++
Obsoletes: egcs-c++, gcc-c++ = %version
PreReq: alternatives >= 0.0.6, gcc-c++-common >= 1.4
Requires: %name = %version-%release, libstdc++%gcc_branch-devel = %version-%release

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does include the static standard C++
library and C++ header files; the library for dynamically linking
programs is available separately.

%package g77
Summary: Fortran 77 support for gcc
Group: Development/Other
Provides: gcc-g77 = %compat_verrel, %_bindir/%_target_platform-g77, %_bindir/g77
Obsoletes: egcs-g77, gcc-g77 = %version
PreReq: alternatives >= 0.0.6, gcc-g77-common >= 1.4
Requires: %name = %version-%release

%description g77
This package provides support for compiling Fortran 77
programs with the GNU gcc compiler.

%package -n libobjc%gcc_branch
Summary: Objective C runtime libraries
Group: System/Libraries
Provides: libobjc = %compat_verrel
Obsoletes: libobjc = %version
PreReq: gcc-common >= 1.4
Conflicts: libobjc < %version, libobjc > %version

%description -n libobjc%gcc_branch
Runtime libraries for the GNU Objective C Compiler.

%package objc
Summary: Objective C support for gcc
Group: Development/Other
Provides: gcc-objc = %compat_verrel
Obsoletes: egcs-objc, gcc-objc = %version
PreReq: alternatives >= 0.0.6, gcc-common >= 1.4
Requires: %name = %version-%release, libobjc%gcc_branch = %version-%release

%description objc
This package provides Objective C support for the GNU C compiler (gcc).
Mainly used on systems running NeXTSTEP, Objective C is an
object-oriented derivative of the C language.

%package java
Summary: Java support for gcc
Group: Development/Java
Provides: gcc-java = %compat_verrel, %_bindir/%_target_platform-gcj, %_bindir/gcj
Obsoletes: egcs-java, gcc-java = %version
PreReq: alternatives >= 0.0.6, gcc-java-common >= 1.4
Requires: %name = %version-%release, libgcj-devel = %version
%{?_with_java:BuildPreReq: libgcj-devel = %version}

%description java
This package adds experimental support for compiling Java(tm) programs and
bytecode into native code. To use this you will also need the libgcj and
libgcj-devel packages.

%package doc
Summary: GCC documentation
Group: Development/Other
Provides: gcc-doc = %compat_verrel
Obsoletes: gcc-doc = %version
PreReq: %__install_info
Conflicts: gcc-doc < %version, gcc-doc > %version

%description doc
GCC is a compiler suite aimed at integrating all the optimizations and
features necessary for a high-performance and stable development
environment. This package contains the compiler printable
documentation in PDF, as well as the INFO pages.

%prep
%setup -q -n gcc-%SRC_VERSION-%SNAPSHOT

# RH
%patch10 -p0 -b .sparc
%patch11 -p0 -b .sparc1
%patch12 -p0 -b .sparc2
%patch13 -p0 -b .sparc3
%patch14 -p0 -b .sparc4
%patch15 -p0 -b .sparc5
%patch16 -p0 -b .sparc6
%patch18 -p0 -b .jword
%patch19 -p0 -b .memcpy
%patch20 -p0 -b .sparcv9
%if %LIBSTDCXX_V3
%patch2 -p0 -b .new_abi
%endif
%patch4 -p0 -b .typedef
%patch5 -p0 -b .trigraph
%patch6 -p0 -b .incompl
%patch8 -p0 -b .wnoerror
%patch9 -p0 -b .stringcrash
%patch21 -p0 -b .stmtexpr
%ifarch sparc
%patch22 -p0 -b .sparc32hack
if [ ! -f /usr/lib64/crt1.o ]; then
%patch23 -p0 -b .sparc32hack2
fi
%endif
%patch25 -p0 -b .hack
%patch28 -p0 -b .loop
%patch29 -p0 -b .addressof
%patch31 -p0 -b .regmoveasm
%patch33 -p0 -b .cpplib
%patch35 -p0 -b .cpp0
%patch36 -p0 -b .canoncond
%patch37 -p0 -b .bogussubreg
%patch38 -p0 -b .cpii
%patch39 -p0 -b .subreggcse
%patch40 -p0 -b .subregbytegcse
%patch41 -p0 -b .combinecomparison
%patch42 -p0 -b .loopnoopt
%patch43 -p0 -b .loopunroll
%patch44 -p0 -b .looptest1
%patch45 -p0 -b .looptest2
%patch46 -p0 -b .loopscanloop
%patch48 -p0 -b .ashlsilea
%patch49 -p0 -b .lea
%patch50 -p0 -b .lowparttest
%patch51 -p0 -b .loopnoopt2
%patch52 -p0 -b .i386sib
%patch53 -p0 -b .cppwarn
%patch54 -p0 -b .wintt
%patch55 -p0 -b .fmtchk
%patch56 -p0 -b .strftime
%patch57 -p0 -b .xopen
%patch58 -p0 -b .c99std
%patch59 -p0 -b .iso-not-ansi
%patch60 -p0 -b .sibcall
%patch61 -p0 -b .ostest
%patch62 -p0 -b .java-misc
%patch63 -p0 -b .java-bytecode
%patch64 -p0 -b .java-pg
# These two are buggy
#%patch65 -p0 -b .cmtable
#%patch66 -p0 -b .relational
%patch67 -p0 -b .finclude
%patch68 -p0 -b .unroll
%patch69 -p0 -b .i386-strops
%patch70 -p0 -b .simplify-rela
%patch71 -p0 -b .alias
%patch72 -p0 -b .jsm1
%patch73 -p0 -b .jsm2
%patch74 -p0 -b .jsm3
%patch75 -p0 -b .scanf
%patch76 -p0 -b .jsm4
%patch77 -p0 -b .jsm5
%patch78 -p0 -b .jsm6
%patch79 -p0 -b .jsm7
%patch80 -p0 -b .jsm8
%patch81 -p0 -b .loop-hack
%patch82 -p0 -b .cpp-warnpaste
%patch83 -p0 -b .float-condmove
# These two are also buggy
%patch84 -p0 -b .i386-call
%patch85 -p0 -b .i386-call2
%patch86 -p0 -b .i386-call-test
%patch87 -p0 -b .i386-arith
%patch88 -p0 -b .i386-ge_geu
%patch89 -p0 -b .i386-gotoff
%patch90 -p0 -b .java-catchup
%patch91 -p0 -b .java-no-super-layout
%patch92 -p0 -b .make-extraction
%patch93 -p0 -b .segv1
%patch94 -p0 -b .segv2
%patch95 -p0 -b .copy-leaf-remap
%patch96 -p0 -b .wchar-const
%patch97 -p0 -b .libio
%patch98 -p0 -b .alpha-tune
%patch99 -p0 -b .alpha-unaligned
%patch100 -p0 -b .cpp-warnpaste2
%patch101 -p0 -b .loop-giv
%patch102 -p0 -b .real-value
%patch103 -p0 -b .sparc-const-pool
%patch104 -p0 -b .sparc64-timode
%patch105 -p0 -b .callersave-segv
%patch106 -p0 -b .libio-printf_fp
%patch107 -p0 -b .pt-enum
%patch108 -p0 -b .sparc-pic
%patch109 -p0 -b .subreg-byte-expmed
%patch110 -p0 -b .test-991206-1
%patch111 -p0 -b .alpha-mi-thunk
%patch112 -p0 -b .c++-pmf
%patch113 -p0 -b .f77-fdebug
%patch114 -p0 -b .libio-endl
%patch115 -p0 -b .i386-compare-test
%patch116 -p0 -b .sparc-may-trap
%patch117 -p0 -b .sparc-mi-thunk
%patch118 -p0 -b .c++-inline16-test
%patch119 -p0 -b .c++-named-return-value
%patch120 -p0 -b .c++-walk-tree
%patch121 -p0 -b .i386-reload-test
%patch122 -p0 -b .i386-reload
%patch123 -p0 -b .sibcall-unchanging
%patch124 -p0 -b .segv3
%patch125 -p0 -b .c++-crash24
%patch126 -p0 -b .do-store-flag
%patch127 -p0 -b .i386-address-cost
%patch128 -p0 -b .i386-arith2
%patch129 -p0 -b .i386-constraint-N
%patch130 -p0 -b .incomplete-aggregate-alias
%patch131 -p0 -b .sibcall-eh2
%patch132 -p0 -b .cpp-assert-crash
%patch133 -p0 -b .c++-undefined-method
%patch134 -p0 -b .sparc-4096
%patch135 -p0 -b .sparc64-reload-test
%patch136 -p0 -b .sparc64-reload2
%patch137 -p0 -b .subreg-byte-operand-subword
%patch139 -p0 -b .c++-static-class
%patch140 -p0 -b .c++-testset1
%patch141 -p0 -b .c++-testset2
%patch142 -p0 -b .place-field
%patch143 -p0 -b .sparc-output-formatting
%patch144 -p0 -b .sparc64-mi-thunk
%patch145 -p0 -b .sparc64-namedret
%patch146 -p0 -b .sparc64-nested-fn
%patch147 -p0 -b .c++-ice
%patch148 -p0 -b .alpha-fold-const
%patch149 -p0 -b .alpha-recog
%patch150 -p0 -b .c++-pointer-to-member-test
%patch151 -p0 -b .c++-sizetype
%patch152 -p0 -b .cpp-64k
%patch153 -p0 -b .cpp-empty-header
%patch154 -p0 -b .i386-regelim
%patch155 -p0 -b .sparc-builtin-setjmp
%patch156 -p0 -b .test-loop-7
%patch157 -p0 -b .c++-dump-expr
%patch158 -p0 -b .c++-inline-cmp
%patch159 -p0 -b .c++-inline-return
%patch160 -p0 -b .c++-label-scope
%patch161 -p0 -b .c++-ptm
%patch162 -p0 -b .c++-qual-error
%patch163 -p0 -b .const-fold
%patch164 -p0 -b .cpp-error-directive
%ifarch %ix86
%patch165 -p0 -b .i386-truncxfsf
%endif
%patch166 -p0 -b .integrate-clobber
%patch167 -p0 -b .libf2c-mkstemp
%patch168 -p0 -b .local-alloc
%patch169 -p0 -b .loop-hoistmem
%patch170 -p0 -b .sibcall-const
%patch171 -p0 -b .sibcall-emit-queue
%patch172 -p0 -b .unroll-iterations
%patch173 -p0 -b .volatile-local-var
%patch174 -p0 -b .c++-sizetype2
%patch175 -p0 -b .error-diagnostic
%patch176 -p0 -b .aggregate-mode
%patch177 -p0 -b .c++-addressof
%patch178 -p0 -b .aggregate-mode2
%patch179 -p0 -b .c++-addressof2
%patch180 -p0 -b .c++-inline-cmp2.patch
%patch181 -p0 -b .cpp-fno-operator-names
%patch182 -p0 -b .c++-ggc-input
%patch183 -p0 -b .alpha-unaligned2
%patch184 -p0 -b .alpha-ze_and_ne
%patch185 -p0 -b .c++-wchar_t
%patch186 -p0 -b .cpp-arg-loop
%patch187 -p0 -b .cpp-fno-operator-names2
%patch188 -p0 -b .cpp-g3
%patch189 -p0 -b .fshort-wchar
%patch190 -p0 -b .max-strlen
%patch191 -p0 -b .stabs
%patch192 -p0 -b .subreg-byte-gcse2
%patch193 -p0 -b .tradcpp-MD
%patch194 -p0 -b .alpha-expand-block-move
%patch195 -p0 -b .c++-decl-needed
%patch196 -p0 -b .c++-nomods_initdcl0
%patch197 -p0 -b .cpp-MD
%patch198 -p0 -b .fixup-var-refs
%patch199 -p0 -b .frame-related
%patch200 -p0 -b .i386-cmpqi
# This one depends on buggy 84 & 85.
%patch201 -p0 -b .i386-const-call-address
%patch202 -p0 -b .i386-fcmov
%patch203 -p0 -b .i386-sar
%patch204 -p0 -b .c++-extern-c
%patch205 -p0 -b .c++-inline-static
%patch206 -p0 -b .c++-inline-static2
%patch207 -p0 -b .cpp-M-include
%patch208 -p0 -b .integrate-compare
%setup -qTD -n gcc-%SRC_VERSION-%SNAPSHOT -a2
%patch209 -p0 -b .cpp-20010126
%patch210 -p0 -b .objc-cpp-lineno
%patch211 -p0 -b .cpp-paste-avoid
%patch212 -p0 -b .cpp-paste-avoid2
%patch213 -p0 -b .c++-inline-modify_expr
%patch214 -p0 -b .i386-testqi_1
%patch215 -p0 -b .c++-anon-union
%patch216 -p0 -b .extract_bit_field
%patch217 -p0 -b .c++-overload-warn
%patch218 -p0 -b .cpp-implicit-extern-c
%patch219 -p0 -b .cpp-paste-avoid3
%patch220 -p0 -b .packed-enum-bitfield
%patch221 -p0 -b .variable-size
%ifarch ia64
%patch222 -p0 -b .ia64
%patch223 -p0 -b .ia64-errata
%endif
%patch224 -p0 -b .cpp-defined-diag
%patch225 -p0 -b .cpp-paste-avoid4
%patch226 -p0 -b .dwarf2out-ice
%patch227 -p0 -b .g++.jason-2371
%patch228 -p0 -b .lex-line
%patch229 -p0 -b .alpha-unaligned3
%setup -qTD -n gcc-%SRC_VERSION-%SNAPSHOT -a3
%patch230 -p0 -b .consistency
%patch231 -p0 -b .nested-parm
%patch232 -p0 -b .alpha-reload
%patch233 -p0 -b .alpha-shift
%patch234 -p0 -b .c++-init-copy-aggr
%patch235 -p0 -b .c++-inline-loop
%patch236 -p0 -b .c++-lookup
%patch237 -p0 -b .c++-taking-address-error
%patch238 -p0 -b .objc-gc
%patch239 -p0 -b .objc-test
%patch240 -p0 -b .reload-hardreg-free
%patch241 -p0 -b .cpp-20010222
%patch242 -p0 -b .expr-safety
%patch243 -p0 -b .debug-static-local
%patch244 -p0 -b .fixup-var-refs2
%patch245 -p0 -b .fold-const-div
%patch246 -p0 -b .g77-unused
%ifarch ia64
%patch247 -p0 -b .ia64-flushrs
%patch248 -p0 -b .ia64-syscall-linkage
%endif
%patch249 -p0 -b .recog-addressof
%patch250 -p0 -b .cpp-20010309
%patch251 -p0 -b .cant-combine
%patch252 -p0 -b .i386-crtendS
%patch253 -p0 -b .reg-stack-clobber
%patch254 -p0 -b .reg-stack
%patch255 -p0 -b .store-expr
%patch256 -p0 -b .target-expr
%patch257 -p0 -b .c++-anonaggr-copy
%patch258 -p0 -b .c++-asmspec
%patch259 -p0 -b .c++-static-local
%patch260 -p0 -b .f77-line
%patch261 -p0 -b .libstdc++-getline
%patch262 -p0 -b .no-new-abi
%patch263 -p0 -b .regrename
%patch264 -p0 -b .subreg-byte-gcse3
%patch265 -p0 -b .wshadow-doc
%patch266 -p0 -b .c++-D__EXCEPTIONS
%patch267 -p0 -b .c++-throttle-inline
%patch268 -p0 -b .fold-pointer-cmp
%patch269 -p0 -b .ifcvt-strict-low-part
%patch270 -p0 -b .gcse-reg-equiv
%patch271 -p0 -b .null-pointer-check
%patch272 -p0 -b .local-inline

%patch273 -p0 -b .cpp-Wcomment
%patch274 -p0 -b .cselib-mode
%patch275 -p0 -b .dwarf2-O0-crash
%patch276 -p0 -b .dwarf2out-splice-child
%patch277 -p0 -b .i386-movcc
%patch278 -p0 -b .ia64-xdata
%patch279 -p0 -b .subregbyte-hard-regno
%patch280 -p0 -b .tradtradcpp0
%patch281 -p0 -b .flow-autoinc
%patch282 -p0 -b .ia64-constconst
%patch283 -p0 -b .ia64-G
%patch284 -p0 -b .integrate-error
%patch285 -p0 -b .MD-nodot
%patch286 -p0 -b .store-constructor-field
%ifarch ia64
%patch287 -p0 -b .ia64-expect
%patch288 -p0 -b .ia64-loc79
# Add -mb-step automatically -- this will go away when production
# hardware is available.
%patch289 -p0 -b .ia64-bstep
%endif
%patch290 -p0 -b .c++-templ-arg
%patch291 -p0 -b .frame-state-for-compat
%patch292 -p0 -b .sibcall-catch
%patch293 -p0 -b .tradcpp-define
%patch294 -p0 -b .c++-inline-method
%patch295 -p0 -b .gcse-trapping
%patch296 -p0 -b .nested-expr-stmt
%patch297 -p0 -b .__NO_INLINE__
%patch298 -p0 -b .bogus-inline
%patch299 -p0 -b .c++-defarg
%patch300 -p0 -b .c++-instantiate
%patch301 -p0 -b .c++-static-ctordtor
%patch302 -p0 -b .c++-templ-arg2
%patch303 -p0 -b .c++-ucs
%patch304 -p0 -b .fsyntax-only
%patch305 -p0 -b .g77-unsigned-char
%patch306 -p0 -b .hash-ident
#%patch307 -p0 -b .jump-threading
%patch308 -p0 -b .regmove-unchanging
%ifarch ia64
%patch309 -p0 -b .ia64-complex-float
%patch310 -p0 -b .ia64-movcc-fail
%patch311 -p0 -b .ia64-stop-bit
%endif
%patch312 -p0 -b .c++-friend
%patch313 -p0 -b .i386-stack-adjust
%patch314 -p0 -b .SHF_MERGE
%patch315 -p0 -b .dwarf2-filenames
%patch316 -p0 -b .k6-loop
%patch317 -p0 -b .libobjc-3.0
%patch318 -p0 -b .texinfo-texconfig
%patch319 -p0 -b .c++-complext
%patch320 -p0 -b .c++-conv-cv-ptr
%patch321 -p0 -b .c++-sstream-warn
%patch322 -p0 -b .f77-ffixed
%patch323 -p0 -b .invalid-stabs
%patch324 -p0 -b .libio-test
%patch325 -p0 -b .alpha-function-sections
%patch326 -p0 -b .alpha-vtable-gc
%patch327 -p0 -b .c++-anontypename
%patch328 -p0 -b .c++-array-cast
%patch329 -p0 -b .c++-colonequal
%patch330 -p0 -b .c++-cond-ovl
%patch331 -p0 -b .c++-weak-address
%patch332 -p0 -b .libio-input-float
%patch333 -p0 -b .subreg-byte-stabs
%patch334 -p0 -b .c++-array-side-effects
%patch335 -p0 -b .cpp-memleak
%patch336 -p0 -b .c++-template-throw
%patch337 -p0 -b .c++-tsubst-friend-class
%patch338 -p0 -b .dwarf2-debug-line
%patch339 -p0 -b .ifcvt-eh
%patch340 -p0 -b .ia64-vararg
%patch341 -p0 -b .gcse-hoist
%ifarch ia64
%patch342 -p0 -b .ia64-eh
%endif
%patch343 -p0 -b .libio-stdstream-offset
%patch344 -p0 -b .objc-class-ref
%patch345 -p0 -b .tail-recurse
%patch346 -p0 -b .c++-sstream-seek
%patch347 -p0 -b .loop-combine-givs
%patch348 -p0 -b .alpha-asm-input
%patch349 -p0 -b .c++-anon-union2
%patch350 -p0 -b .c++-inline-sizeof-char
%patch351 -p0 -b .cpp-run-directive
%patch352 -p0 -b .reload-optional
%patch353 -p0 -b .fde-merge-compat
%patch354 -p0 -b .flow-setjmp
%patch355 -p0 -b .pure-reload
%patch356 -p0 -b .sparc-float
%patch357 -p0 -b .sparc-movdf
%patch358 -p0 -b .c++-member-init
%patch359 -p0 -b .autoconf-2.52
%patch360 -p0 -b .makej
%ifarch ia64
%patch361 -p0 -b .ia64-bitfield-return
%patch362 -p0 -b .ia64-NaT
%endif
%ifarch sparc sparc64
%patch363 -p0 -b .sparc-libcall
%endif
#%patch364 -p0 -b .c++-preexpand-calls
%patch365 -p0 -b .libio-stdstreams-vptr
%patch366 -p0 -b .sparc-return
%patch367 -p0 -b .sparc64-nonzero-bits
%patch368 -p0 -b .below-sp
%patch369 -p0 -b .c++-setup-vtbl-ptr
%patch370 -p0 -b .reload-ofp
%patch371 -p0 -b .bitop-shorten
%patch372 -p0 -b .c++-ptrintsum
%patch373 -p0 -b .i386-fxch
%patch374 -p0 -b .i386-regparm-struct
%patch375 -p0 -b .ia64-encode-section-info
%patch376 -p0 -b .attr-visibility
%patch377 -p0 -b .store_field-expand_and
%patch378 -p0 -b .c++-array-ref
%patch379 -p0 -b .c++-flat-initializer
%patch380 -p0 -b .c++-static-member
%patch381 -p0 -b .i386-reg-stack-check
%patch382 -p0 -b .i386-zero-size
%patch383 -p0 -b .loop-check_dbra_loop
%patch384 -p0 -b .pedwarn-string-length
%patch385 -p0 -b .simplify-check-overflow
%patch386 -p0 -b .UDA-option-order
%patch387 -p0 -b .c++-pt-using
%patch388 -p0 -b .c++-pt-using2
%patch389 -p0 -b .attr-visibility2
%patch390 -p0 -b .libstdc++-libc-interface
%patch391 -p0 -b .attr-visibility3
%ifarch ia64
%patch392 -p0 -b .ia64-thread-safe-eh
%endif
%patch393 -p0 -b .merge_blocks_nomove
%patch394 -p0 -b .attr-visibility4
%ifarch ia64
%patch395 -p0 -b .unaligned-const
%endif
%patch396 -p0 -b .i386-piclabel
%patch397 -p0 -b .2.96-parallel
%patch398 -p0 -b .i386-andhi
%patch399 -p0 -b .mem-scratch
%patch400 -p0 -b .unroll2
%patch401 -p0 -b .sparc-tfdi
%patch402 -p0 -b .c++-gc-named-label-list
%patch403 -p0 -b .cpp-include-dir
%patch404 -p0 -b .c++-compound-literal
%patch405 -p0 -b .c++-eh-spec-incomplete
%patch406 -p0 -b .fde-merge-compat-2
%patch407 -p0 -b .strict-alias-optimization
%patch408 -p0 -b .cpp-MD-2

# Debian
%patch900 -p1

# ALT
%patch1000 -p1
#%patch1001 -p1
#%patch1002 -p1
%patch1003 -p1
%patch1004 -p1
%patch1005 -p1
%patch1006 -p0

# FIX SHF_MERGE stuff so that it uses "aMS" and "aM" instead of "ams" and "am".
perl -pi -e 's/"ams/"aMS/' gcc/configure.in gcc/configure gcc/config/elfos.h gcc/config/alpha/elf.h
perl -pi -e 's/"am/"aM/' gcc/configure.in gcc/configure gcc/config/elfos.h gcc/config/alpha/elf.h

# Set proper version & contact info.
perl -pi -e 's/\(experimental\)/\(%os_release\)/' gcc/version.c gcc/f/version.c
perl -pi -e 's,#define GCCBUGURL.*$,#define GCCBUGURL "<URL:http://bugs.altlinux.ru/>",' gcc/system.h

%build
%define buildtarget build-%_target_platform
rm -rf %buildtarget
mkdir %buildtarget
pushd %buildtarget

%if %LIBSTDCXX_V3
ENABLE_LIBSTDCXX_V3="--enable-libstdcxx-v3 --enable-new-gxx-abi --enable-long-long --enable-cshadow-headers --enable-namespaces"
%else
ENABLE_LIBSTDCXX_V3=
%endif
CC="$CC" \
CFLAGS="$RPM_OPT_FLAGS" \
CXXFLAGS="$RPM_OPT_FLAGS" \
XCFLAGS="$RPM_OPT_FLAGS" \
TCFLAGS="$RPM_OPT_FLAGS" \
	../configure --prefix=%prefix --mandir=%_mandir --infodir=%_infodir \
	--enable-shared --enable-threads=posix --enable-haifa --disable-checking $ENABLE_LIBSTDCXX_V3 \
	--enable-languages="c,c++,f77%{?_with_objc:,objc}%{?_with_java:,java}" \
	--host=%_target_platform --build=%_target_platform --target=%_target_platform

touch ../gcc/c-gperf.h

%make_build bootstrap-lean

%if_with check
# Run the tests.
make -k check
%endif #with check

# Make protoize
make -C gcc CC="./xgcc -B ./ $RPM_OPT_FLAGS" proto

popd # %buildtarget

%install
%__mkdir_p $RPM_BUILD_ROOT%gcc_doc_dir

# Copy various doc files here and there
CopyDocs()
{
	local n="$1"
	shift
	%__mkdir_p "$RPM_BUILD_ROOT%gcc_doc_dir/$n"
	local d="$1"
	shift
	local f
	for f in "$d"/*{README,NEWS,ChangeLog,LICENSE,THREADS}*; do
		[ -f "$f" ] || continue
		%__install -pv -m644 "$f" "$RPM_BUILD_ROOT%gcc_doc_dir/$n/"
	done
}

CopyDocs gcc gcc
CopyDocs g++ gcc/cp
CopyDocs libio libio
CopyDocs libstdc++ libstdc++
CopyDocs g77 gcc/f
CopyDocs libg2c libf2c
CopyDocs objc gcc/objc
CopyDocs libobjc libobjc
%{?_with_java:CopyDocs java gcc/java}

%__mkdir_p $RPM_BUILD_ROOT{%_mandir,%_infodir}

pushd %buildtarget

make install \
	prefix=$RPM_BUILD_ROOT%prefix \
	mandir=$RPM_BUILD_ROOT%_mandir \
	infodir=$RPM_BUILD_ROOT%_infodir

FULLVER="$($RPM_BUILD_ROOT%_bindir/%_target_platform-gcc --version |cut -d' ' -f1)"
FULLPATH=$(dirname $RPM_BUILD_ROOT%_libdir/gcc-lib/%_target_platform/$FULLVER/cc1)

popd # %buildtarget

# Rename binaries for update-alternatives.
pushd $RPM_BUILD_ROOT%_bindir
	for f in \
	  cpp \
	  gcc gcov protoize unprotoize \
	  g++ c++filt \
	  g77 \
	  %{?_with_java:gcj gcjh jcf-dump jv-scan} \
	  ; do
		%__mv "$f" "%_target_platform-$f%psuffix"
		%__ln_s "%_target_platform-$f%psuffix" "$f%psuffix"
	done
popd

# Normalize manpage names.
pushd $RPM_BUILD_ROOT%_man1dir
	for f in cpp gcc g++ g77; do
		%__mv "$f".1 "$f"%psuffix.1
	done
popd

pushd $FULLPATH
	%__rm -f libstdc++.so libstdc++.a
	%__mv $RPM_BUILD_ROOT%_libdir/libstdc++* .
%if !%LIBSTDCXX_V3
	%__ln_s libstdc++-libc6*-2.so.3 libstdc++.so
	%__ln_s libstdc++-libc6*-2.a.3 libstdc++.a
	chmod a+x *.so*
%endif
popd
pushd $RPM_BUILD_ROOT%_libdir
	%__ln_s gcc-lib/%_target_platform/$FULLVER/libstdc++* .
	%__ln_s gcc-lib/%_target_platform/$FULLVER/libobjc* .

%if !%LIBSTDCXX_V3
	# This is required for the old gcc-2.95.x-based programs.
	%__ln_s libstdc++-3-libc6.2-2-%STDC_VERSION.so libstdc++-libc6.1-1.so.2
	%__ln_s libstdc++-3-libc6.2-2-%STDC_VERSION.so libstdc++-libc6.1-1.1.so.2
	%__ln_s libstdc++-3-libc6.2-2-%STDC_VERSION.so libstdc++-libc6.1-2.so.2
	%__ln_s libstdc++-3-libc6.2-2-%STDC_VERSION.so libstdc++-libc6.1-2.so.3
	%__ln_s libstdc++-3-libc6.2-2-%STDC_VERSION.so libstdc++-3-libc6.1-2-%STDC_VERSION.so
	%__ln_s -f libstdc++-3-libc6.2-2-%STDC_VERSION.so libstdc++-libc6.2-2.so.3
	%__ln_s libstdc++-3-libc6.2-2-%STDC_VERSION.so libstdc++.so.2.9
%endif
popd

find $RPM_BUILD_ROOT -name lib\*.la -print -delete

# Compress changelogs.
find "$RPM_BUILD_ROOT%gcc_doc_dir/" -type f -iname *changelog\* \! -name \*.bz2 -print0 |
	xargs -r0 bzip2 -9 --

# Correct permissions if required.
chmod 755 $RPM_BUILD_ROOT%_libdir/lib*.so*

# buildreq substitution rules.
%__mkdir_p $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d
for n in cpp gcc gcc-c++ gcc-g77 gcc-java gcc-objc libobjc libstdc++ libstdc++-devel libstdc++-devel-static; do
	pref="${n%%%%-*}"
	suf="${n#$pref}"
	t="${pref}%gcc_branch$suf"
	echo "$n" >"$RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/$t"
done
chmod 644 $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/*

# buildreq ignore rules.
%__mkdir_p $RPM_BUILD_ROOT%_sysconfdir/buildreqs/files/ignore.d
cat >$RPM_BUILD_ROOT%_sysconfdir/buildreqs/files/ignore.d/%name <<EOF
^%gcc_target_dir(/include)?$
EOF

%find_lang gcc

%set_strip_method executable
%set_compress_method bzip2

#install alternatives stuff
%__install -d $RPM_BUILD_ROOT%_altdir
cat >$RPM_BUILD_ROOT%_altdir/cpp%gcc_branch<<EOF
<group name="candidate">
    <option name="link">%_bindir/%_target_platform-cpp</option>
    <option name="real">%_bindir/%_target_platform-cpp%psuffix</option>
    <xinclude:include href="/etc/gcc-common/gcc-%gcc_branch" parse="xml" xmlns:xinclude="http://www.w3.org/2001/XInclude"/>
    <group name="slave">
        <option name="link">%_man1dir/cpp.1.bz2</option>
        <option name="real">%_man1dir/cpp%psuffix.1.bz2</option>
    </group>
</group>
EOF

cat >$RPM_BUILD_ROOT%_altdir/%name<<EOF
<group name="candidate">
    <option name="link">%_bindir/%_target_platform-gcc</option>
    <option name="real">%_bindir/%_target_platform-gcc%psuffix</option>
    <xinclude:include href="/etc/gcc-common/gcc-%gcc_branch" parse="xml" xmlns:xinclude="http://www.w3.org/2001/XInclude"/>
    <group name="slave">
        <option name="link">%_bindir/%_target_platform-gcov</option>
        <option name="real">%_bindir/%_target_platform-gcov%psuffix</option>
    </group>
    <group name="slave">
        <option name="link">%_bindir/%_target_platform-protoize</option>
        <option name="real">%_bindir/%_target_platform-protoize%psuffix</option>
    </group>
    <group name="slave">
        <option name="link">%_bindir/%_target_platform-unprotoize</option>
        <option name="real">%_bindir/%_target_platform-unprotoize%psuffix</option>
    </group>
    <group name="slave">
        <option name="link">%_man1dir/gcc.1.bz2</option>
        <option name="real">%_man1dir/gcc%psuffix.1.bz2</option>
    </group>
    <group name="slave">
        <option name="link">%_man1dir/gcov.1.bz2</option>
        <option name="real">%_man1dir/gcov%psuffix.1.bz2</option>
    </group>
</group>
EOF

cat >$RPM_BUILD_ROOT%_altdir/c++%gcc_branch<<EOF
<group name="candidate">
    <option name="link">%_bindir/%_target_platform-g++</option>
    <option name="real">%_bindir/%_target_platform-g++%psuffix</option>
    <xinclude:include href="/etc/gcc-common/gcc-%gcc_branch" parse="xml" xmlns:xinclude="http://www.w3.org/2001/XInclude"/>
    <group name="slave">
        <option name="link">%_bindir/%_target_platform-c++filt</option>
        <option name="real">%_bindir/%_target_platform-c++filt%psuffix</option>
    </group>
    <group name="slave">
        <option name="link">%_man1dir/g++.1.bz2</option>
        <option name="real">%_man1dir/g++%psuffix.1.bz2</option>
    </group>
</group>
EOF

cat >$RPM_BUILD_ROOT%_altdir/g77%gcc_branch<<EOF
<group name="candidate">
    <option name="link">%_bindir/%_target_platform-g77</option>
    <option name="real">%_bindir/%_target_platform-g77%psuffix</option>
    <xinclude:include href="/etc/gcc-common/gcc-%gcc_branch" parse="xml" xmlns:xinclude="http://www.w3.org/2001/XInclude"/>
    <group name="slave">
        <option name="link">%_man1dir/g77.1.bz2</option>
        <option name="real">%_man1dir/g77%psuffix.1.bz2</option>
    </group>
</group>
EOF

%if_with java
cat >$RPM_BUILD_ROOT%_altdir/java%gcc_branch<<EOF
<group name="candidate">
    <option name="link">%_bindir/%_target_platform-gcj</option>
    <option name="real">%_bindir/%_target_platform-gcj%psuffix</option>
    <xinclude:include href="/etc/gcc-common/gcc-%gcc_branch" parse="xml" xmlns:xinclude="http://www.w3.org/2001/XInclude"/>
    <group name="slave">
        <option name="link">%_bindir/%_target_platform-gcjh</option>
        <option name="real">%_bindir/%_target_platform-gcjh%psuffix</option>
    </group>
    <group name="slave">
        <option name="link">%_bindir/%_target_platform-gij</option>
        <option name="real">%_bindir/%_target_platform-gij%psuffix</option>
    </group>
    <group name="slave">
        <option name="link">%_bindir/%_target_platform-jcf-dump</option>
        <option name="real">%_bindir/%_target_platform-jcf-dump%psuffix</option>
    </group>
    <group name="slave">
        <option name="link">%_bindir/%_target_platform-jv-scan</option>
        <option name="real">%_bindir/%_target_platform-jv-scan%psuffix</option>
    </group>
    <group name="slave">
        <option name="link">%_bindir/%_target_platform-grepjar</option>
        <option name="real">%_bindir/%_target_platform-grepjar%psuffix</option>
    </group>
    <group name="slave">
        <option name="link">%_bindir/%_target_platform-jar</option>
        <option name="real">%_bindir/%_target_platform-jar%psuffix</option>
    </group>
    <group name="slave">
        <option name="link">%_bindir/%_target_platform-rmic</option>
        <option name="real">%_bindir/%_target_platform-rmic%psuffix</option>
    </group>
    <group name="slave">
        <option name="link">%_bindir/%_target_platform-rmiregistry</option>
        <option name="real">%_bindir/%_target_platform-rmiregistry%psuffix</option>
    </group>
    <group name="slave">
        <option name="link">%_man1dir/gcj.1.bz2</option>
        <option name="real">%_man1dir/gcj%psuffix.1.bz2</option>
    </group>
    <group name="slave">
        <option name="link">%_man1dir/gij.1.bz2</option>
        <option name="real">%_man1dir/gij%psuffix.1.bz2</option>
    </group>
</group>
EOF
%endif

%post -n cpp%gcc_branch
%register_alternatives cpp%gcc_branch -- %_target_platform-cpp cpp.1.bz2

%triggerpostun -n cpp%gcc_branch -- cpp
%register_alternatives cpp%gcc_branch -- %_target_platform-cpp cpp.1.bz2

%preun -n cpp%gcc_branch
%unregister_alternatives cpp%gcc_branch

%triggerun -n cpp%gcc_branch -- cpp2.96 < 0:2.96-alt3
[ $2 != 0 ] || exit 0
[ -x /usr/sbin/update-alternatives ] && /usr/sbin/update-alternatives --remove cpp %_bindir/cpp%psuffix ||:

%post
%register_alternatives %name -- %_target_platform-gcc %_target_platform-gcov %_target_platform-protoize %_target_platform-unprotoize gcc.1.bz2 gcov.1.bz2

%triggerpostun -- gcc
%register_alternatives %name -- %_target_platform-gcc %_target_platform-gcov %_target_platform-protoize %_target_platform-unprotoize gcc.1.bz2 gcov.1.bz2

%preun
%unregister_alternatives %name

%triggerun -- gcc2.96 < 0:2.96-alt3
[ $2 != 0 ] || exit 0
[ -x /usr/sbin/update-alternatives ] && /usr/sbin/update-alternatives --remove gcc %_bindir/gcc%psuffix ||:
[ -x /usr/sbin/update-alternatives ] && /usr/sbin/update-alternatives --remove %_target_platform-gcc %_bindir/gcc%psuffix ||:

%post c++
%register_alternatives c++%gcc_branch -- %_target_platform-g++ %_target_platform-c++filt g++.1.bz2

%triggerpostun c++ -- gcc-c++
%register_alternatives c++%gcc_branch -- %_target_platform-g++ %_target_platform-c++filt g++.1.bz2

%preun c++
%unregister_alternatives c++%gcc_branch

%triggerun c++ -- gcc2.96-c++ < 0:2.96-alt3
[ $2 != 0 ] || exit 0
[ -x /usr/sbin/update-alternatives ] && /usr/sbin/update-alternatives --remove g++ %_bindir/g++%psuffix ||:
[ -x /usr/sbin/update-alternatives ] && /usr/sbin/update-alternatives --remove %_target_platform-g++ %_bindir/g++%psuffix ||:

%post g77
%register_alternatives g77%gcc_branch -- %_target_platform-g77 g77.1.bz2

%triggerpostun g77 -- gcc-g77
%register_alternatives g77%gcc_branch -- %_target_platform-g77 g77.1.bz2

%preun g77
%unregister_alternatives g77%gcc_branch

%triggerun g77 -- gcc2.96-g77 < 0:2.96-alt3
[ $2 != 0 ] || exit 0
[ -x /usr/sbin/update-alternatives ] && /usr/sbin/update-alternatives --remove g77 %_bindir/g77%psuffix ||:
[ -x /usr/sbin/update-alternatives ] && /usr/sbin/update-alternatives --remove %_target_platform-g77 %_bindir/g77%psuffix ||:

%post java
%register_alternatives java%gcc_branch -- %_target_platform-gcj %_target_platform-gcjh %_target_platform-gij %_target_platform-jcf-dump %_target_platform-jv-scan %_target_platform-grepjar %_target_platform-jar %_target_platform-rmic %_target_platform-rmiregistry gcj.1.bz2 gij.1.bz2

%triggerpostun java -- gcc-java
%register_alternatives java%gcc_branch -- %_target_platform-gcj %_target_platform-gcjh %_target_platform-gij %_target_platform-jcf-dump %_target_platform-jv-scan %_target_platform-grepjar %_target_platform-jar %_target_platform-rmic %_target_platform-rmiregistry gcj.1.bz2 gij.1.bz2

%preun java
%unregister_alternatives java%gcc_branch

%triggerun java -- gcc2.96-java < 0:2.96-alt3
[ $2 != 0 ] || exit 0
[ -x /usr/sbin/update-alternatives ] && /usr/sbin/update-alternatives --remove gcj %_bindir/gcj%psuffix ||:
[ -x /usr/sbin/update-alternatives ] && /usr/sbin/update-alternatives --remove %_target_platform-gcj %_bindir/gcj%psuffix ||:

%post -n libstdc++%gcc_branch -p %post_ldconfig
%postun -n libstdc++%gcc_branch -p %postun_ldconfig

%post -n libobjc%gcc_branch -p %post_ldconfig
%postun -n libobjc%gcc_branch -p %postun_ldconfig

%post doc
%install_info {cpp,gcc,g77}.info

%preun doc
%uninstall_info {cpp,gcc,g77}.info

%files -n cpp%gcc_branch
%config %_sysconfdir/buildreqs/packages/substitute.d/cpp%gcc_branch
%config %_altdir/cpp%gcc_branch
%_bindir/cpp%psuffix
%_bindir/%_target_platform-cpp%psuffix
%_man1dir/cpp%psuffix.1*
%dir %gcc_target_dir
%gcc_target_dir/*cpp*

%files -f gcc.lang
%config %_sysconfdir/buildreqs/packages/substitute.d/%name
%config %_sysconfdir/buildreqs/files/ignore.d/%name
%config %_altdir/%name
%dir %gcc_doc_dir
%gcc_doc_dir/gcc
%_bindir/gcc%psuffix
%_bindir/gcov%psuffix
%_bindir/protoize%psuffix
%_bindir/unprotoize%psuffix
%_bindir/%_target_platform-gcc%psuffix
%_bindir/%_target_platform-gcov%psuffix
%_bindir/%_target_platform-protoize%psuffix
%_bindir/%_target_platform-unprotoize%psuffix
%dir %gcc_target_dir
%dir %gcc_target_dir/include
%gcc_target_dir/include/float.h
%gcc_target_dir/include/iso646.h
%gcc_target_dir/include/limits.h
%gcc_target_dir/include/proto.h
%gcc_target_dir/include/stdarg.h
%gcc_target_dir/include/stdbool.h
%gcc_target_dir/include/stddef.h
%gcc_target_dir/include/syslimits.h
%gcc_target_dir/include/varargs.h
%gcc_target_dir/include/README
%gcc_target_dir/cc1
%gcc_target_dir/collect2
%gcc_target_dir/crt*.o
%gcc_target_dir/libgcc.a
%gcc_target_dir/SYSCALLS.c.X
%gcc_target_dir/specs
%_man1dir/gcc%psuffix.1*

%files c++
%config %_sysconfdir/buildreqs/packages/substitute.d/%name-c++
%config %_altdir/c++%gcc_branch
%dir %gcc_doc_dir
%gcc_doc_dir/g++
%_bindir/g++%psuffix
%_bindir/c++filt%psuffix
%_bindir/%_target_platform-g++%psuffix
%_bindir/%_target_platform-c++filt%psuffix
%dir %gcc_target_dir
%gcc_target_dir/cc1plus
%dir %gcc_target_dir/include
%gcc_target_dir/include/cxxabi.h
%gcc_target_dir/include/exception
%gcc_target_dir/include/new*
%gcc_target_dir/include/typeinfo
%_man1dir/g++%psuffix.1*

%files -n libstdc++%gcc_branch
%config %_sysconfdir/buildreqs/packages/substitute.d/libstdc++%gcc_branch
%dir %gcc_target_dir
%gcc_target_dir/libstdc++?*.so*
%_libdir/libstdc++-*.so*
%_libdir/libstdc++.so.*

%files -n libstdc++%gcc_branch-devel
%config %_sysconfdir/buildreqs/packages/substitute.d/libstdc++%gcc_branch-devel
%dir %gcc_doc_dir
%gcc_doc_dir/libstdc++
%dir %gcc_target_dir
%gcc_target_dir/libstdc++.so
%_includedir/g++-3

%files -n libstdc++%gcc_branch-devel-static
%config %_sysconfdir/buildreqs/packages/substitute.d/libstdc++%gcc_branch-devel-static
%dir %gcc_target_dir
%gcc_target_dir/libstdc++*.a*
%_libdir/libstdc++-*.a*

%if_with objc
%files -n libobjc%gcc_branch
%config %_sysconfdir/buildreqs/packages/substitute.d/libobjc%gcc_branch
%_libdir/libobjc.*
%dir %gcc_target_dir
%gcc_target_dir/*objc*

%files objc
%config %_sysconfdir/buildreqs/packages/substitute.d/%name-objc
%dir %gcc_doc_dir
%gcc_doc_dir/libobjc
%gcc_doc_dir/objc
%dir %gcc_target_dir
%gcc_target_dir/*obj
%dir %gcc_target_dir/include
%gcc_target_dir/include/objc
%endif #with objc

%files g77
%config %_sysconfdir/buildreqs/packages/substitute.d/%name-g77
%config %_altdir/g77%gcc_branch
%dir %gcc_doc_dir
%gcc_doc_dir/libg2c
%gcc_doc_dir/g77
%_bindir/g77%psuffix
%_bindir/%_target_platform-g77%psuffix
%dir %gcc_target_dir
%gcc_target_dir/f771
%gcc_target_dir/libg2c.a
%dir %gcc_target_dir/include
%gcc_target_dir/include/g2c.h
%_man1dir/g77%psuffix.1*

%if_with java
%files java
%config %_sysconfdir/buildreqs/packages/substitute.d/%name-java
%config %_altdir/java%gcc_branch
%dir %gcc_doc_dir
%gcc_doc_dir/java
%_bindir/gcj*%psuffix
%_bindir/%_target_platform-gcj*%psuffix
%_bindir/j*%psuffix
%_bindir/%_target_platform-j*%psuffix
%dir %gcc_target_dir
%gcc_target_dir/j*
%endif #with java

%files doc
%_infodir/*.info*

%changelog
* Mon Dec 29 2003 Dmitry V. Levin <ldv@altlinux.org> 2.96-alt6
- Do not package .la files.
- Updated gcc-common dependencies.

* Thu Oct 16 2003 Dmitry V. Levin <ldv@altlinux.org> 2.96-alt5
- Finalized alternatives transition.

* Wed Oct 15 2003 Stanislav Ievlev <inger@altlinux.ru> 2.96-alt4.3
- fix install script

* Wed Oct 15 2003 Stanislav Ievlev <inger@altlinux.ru> 2.96-alt4.2
- added alternatives to g++ manpage, require more recent gcc-common version

* Tue Oct 14 2003 Stanislav Ievlev <inger@altlinux.ru> 2.96-alt4.1
- new alternatives support

* Wed Oct 08 2003 Dmitry V. Levin <ldv@altlinux.org> 2.96-alt4
- Updated gcc-c++-nomods_initdcl0 patch.
- gcc/c-lex.c, gcc/objc/objc-act.c, gcc/cp/pt.c:
  Fixed namespace conflict problem.

* Wed Nov 27 2002 Dmitry V. Levin <ldv@altlinux.org> 2.96-alt3
- Merged with rh-2.96-113:
  * Wed Sep 11 2002 Jakub Jelinek <jakub@redhat.com> 2.96-113
  - when searching includes silently skip subdirectories named
    the same as the include (Neil Booth, #70947, #71227,
    PR preprocessor/2444)
  - make the package relocatable
  - allow forward references to incomplete classes with -fpermissive
    (Jason Merrill)
  - fix C++ front-end bug causing compiler crash (Nathan Sidwell,
    Issue Tracker #4298, PR c++/2914)
  - new patch for Bugzilla #54724 (Jason Merrill, Vladimir Makarov,
    Issue Tracker #6710)
  - fix -fno-strict-aliasing (Vladimir Makarov, Issue Tracker #4226,
    #4227, #1496)
  - -MD fix (Jason Merrill, Issue Tracker #6552)
  * Wed Jul  3 2002 Jakub Jelinek <jakub@redhat.com> 2.96-112
  - fix GC of C++ named labels (Jim Wilson)
  * Tue Jun 11 2002 Jakub Jelinek <jakub@redhat.com> 2.96-111
  - use _Q_lltoq, _Q_qtoll and _Q_qtoull instead of
    __floatditf2, __fixtfdi2 and __fixunstfdi2 on SPARC.
- Removed %_libdir/libstdc++.{so,a} (no longer needed).
- Moved gccbug to separate subpackage (gcc-common).
- Migrated to new alternatives scheme.

* Fri Aug 23 2002 Dmitry V. Levin <ldv@altlinux.org> 2.96-alt2
- Relocated documentation to %_docdir/gcc-%version/.
- Synced alternatives with gcc3.2 branch.
- Added buildreq ignore rules.

* Tue Aug 20 2002 Dmitry V. Levin <ldv@altlinux.org> 2.96-alt1
- Renamed from gcc to gcc2.96; added provides for compatibility.
- Moved libstdc++ static libraries to libstdc++-devel-static subpackage.
- Removed chill.
- gcc: moved gccbug under update-alternatives control.
- c++: moved c++filt under update-alternatives control.
- java: moved gcj, gcjh, jcf-dump, jv-scan under update-alternatives control.
- Added buildreq substitution rules.

* Sat Jun 15 2002 Dmitry V. Levin <ldv@altlinux.org> 2.96-ipl16mdk
- Merged with rh-2.96-110:
  * Fri Apr 12 2002 Jakub Jelinek <jakub@redhat.com> 2.96-110
  - 4 new patches
    - fix andhi abort (#63277)
    - some parallel makefile fixes (H.J.Lu, #62805)
    - fix loop unrolling (Franz Sirl, #63130)
    - don't move stack accesses accross prologue/epilogue stack
      allocation/deallocation (Richard Henderson, PR opt/6165)
  * Tue Mar 26 2002 Jakub Jelinek <jakub@redhat.com> 2.96-109
  - don't output .LPR* pic label into linkonce sections (#61931)
  * Wed Mar 20 2002 Jakub Jelinek <jakub@redhat.com> 2.96-108
  - fix IA-64 packed unaligned structure initializers (PR c/5973)
  - optimize visibility even if DECL_RTL has been already assigned
    when seeing visibility attribute
  * Wed Mar 13 2002 Jakub Jelinek <jakub@redhat.com> 2.96-107
  - make ia64 EH thread safe (#57443)
  - fix ifcvt crash (Richard Henderson)
  * Mon Mar 11 2002 Jakub Jelinek <jakub@redhat.com> 2.96-106
  - properly handle visibility attributes for duplicate decls
  * Tue Mar  5 2002 Jakub Jelinek <jakub@redhat.com> 2.96-105
  - only emit visibility directives only with the definition
  - fix for PR c++/1981 patch by Jason Merrill
  - hardcode libc interface to libc6.2
  - killed clear() hack, not needed anymore (#60097)
  * Wed Feb 27 2002 Jakub Jelinek <jakub@redhat.com> 2.96-104
  - split gcc-ia64.patch into gcc-ia64.patch and
    gcc-ia64-encode-section-info.patch
  - 8 new patches
    - fix bitwise and/or/xor with constant operand in certain cases
      (PR c/3444)
    - fix 64-bit pointer arithmetics in C++ (#58746, PR c++/4401)
    - fix regparm > 0 for functions returning struct (PR target/5755)
    - fix ICE in expand_and (PR c++/4574)
    - backport __attribute__((visibility("hidden"))) patch from 3.2
      branch
    - fix floating point deficiencies on Atlas (Jan Hubicka)
    - using inside template functions (Nathan Sidwell, PR c++/1981)
    - fix for using in templates (Nathan Sidwell, PR c++/2184)
  - 9 new patches from Mandrake gcc
    - fix array references with compound expr and ?: (Richard Henderson)
    - fix C++ flat initializers (Richard Sandiford)
    - handle C++ static member side-effects (Jason Merrill)
- BuildPreReq: rpm-build >= 4.0.4-alt0.7 (if/with logic, ldconfig macros).

* Mon Feb 18 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.96-ipl15mdk
- Repackaged for compatibility with gcc3.0 (goldhead).
- Added requires for proper binutils version (#0000162).
- Corrected requires for cpp and libstdc++ subpackages.
- Relocated /usr/lib/libstdc++.so to libstdc++-devel subpackage.
- Set update-alternatives control on /usr/lib/libstdc++.{so,a}.
- Removed file entries provided by gcc-common package.
- Moved texinfo documentation to gcc-doc subpackage (goldhead).
- Made gcc-{java,objc} packaging conditional.
- Split gcc-objc package into 2 parts.
- Added provides for alternative files.
- Merged with rh-2.96-102:
  * Wed Nov 28 2001 Jakub Jelinek <jakub@redhat.com> 2.96-102
  - 2 new patches
    - fix C++ miscompilation (Mark Mitchell, Jason Merrill)
    - initialize vt pointer in cin/cout/cerr/clog objects (#56119)
  * Tue Nov 20 2001 Jakub Jelinek <jakub@redhat.com> 2.96-101
  - 4 new patches
    - fix make -j issues
    - fix NaT issue with partial structure sets on IA-64 (Andrew MacLeod)
    - likewise when returning structure in registers on IA-64 (Andrew MacLeod)
    - fix SPARC ICE on LAPACK
  * Mon Nov 12 2001 Jakub Jelinek <jakub@redhat.com> 2.96-100
  - 12 new patches
    - fix reload of insns without any reloads (#54571)
    - fix a flow ICE with nonlocal goto handlers (#55259)
    - fix C++ ICE on anonymous union on Alpha/Sparc (#51829)
    - fix Alpha ICE with asm("") (#46626)
    - fix Alpha inlining ICE (#54131)
    - frame unwind compatibility with 7.[12] binutils (#54724)
    - fix ICE on invalid C++ code (Nathan Sidwell, #55948)
    - fix CPP ICE on bogus -D arguments (Neil Booth, #54380, #55744)
    - support autoconf 2.52 (jfalk@netxpress.de)
    - fix SPARC typo in float.h (Alexandre Oliva)
    - fix SPARC ICE on pure function call (John Anglin)
    - fix SPARC ICE in change_address
  * Thu Sep  4 2001 Jakub Jelinek <jakub@redhat.com> 2.96-98
  - 7 new patches
    - fix strength reduction (#53025)
    - support seek*/tell* methods in <sstream> classes (#53011)
    - fix ICE on tail recursion with user label on top (Jeff Law, #51477)
    - fix GCSE bug causing miscompilation with -Os (Diego Novillo, #52131)
    - backport GCC 3.0 fde lookup handling using glibc's _dl_iterate_phdr,
      use proper eh sections for .gnu.linkonce functions to match
      binutils (#49746)
    - fix libstdc++ stdin/stdout/stderr initialization, so that ftell works
      on it even without any prior stdio calls (#52507)
    - fix objc class-ref handling, so that no relocations against .rodata
      section are needed (John David Anglin, Rainer Orth, #52400)
  * Mon Aug 20 2001 Jakub Jelinek <jakub@redhat.com> 2.96-97
  - 7 new patches
    - properly handle throw() exception specifiers in template decls (#51824)
    - fix dwarf-2 .debug_line section generation broken by patch added
      in 2.96-91
    - fix IA-64 varargs handling in presence of additional anonymous arguments
      (#50757)
    - handle error conditions with friend classes gracefully
      (Nathan Sidwell, #51533)
    - handle array initializers with side-effect elements properly
      (Mark Mitchell, #51822)
    - fix a memory leak in cpp (Neil Booth)
    - fix ifcvt breaking eh regions (Richard Henderson, #48835, #51567)
  * Thu Aug  9 2001 Jakub Jelinek <jakub@redhat.com> 2.96-96
  - 9 new patches
    - fix template processing in casts to array (Nathan Sidwell, #45824)
    - don't crash on := in C++ source (#47240)
    - issue declaration does not declare anything instead of ICE
      (Nathan Sidwell, #48093)
    - fix SUBREG_BYTE related stabs bug (#50244)
    - ignore -fvtable-gc on alpha (#48933)
    - fix -ffunction-sections and -fdata-sections on alpha (H.J. Lu, #48581)
    - don't warn about if (&foo) if foo is weak (H.J. Lu, #50855)
    - set fail() if istream cannot extract a floating point variable
      from the stream (#50722)
    - don't allow unresolved overloaded fns in both sides of ?: (Nathan Sidwell)
  * Tue Jul 24 2001 Jakub Jelinek <jakub@redhat.com> 2.96-95
  - 6 new patches
    - fix Fortran -ffixed-line-lengh-132 option (Mark Mitchell, #49326)
    - fix handling of C++ conversions to cv void * (Mark Mitchell, #49188)
    - avoid generating bogus .stabs (#49214)
    - avoid warning in <sstream> (#49799)
    - fix <complex> for -pedantic (#49120)
    - fix make check in libio (#44657)
  * Tue Jul 10 2001 Jakub Jelinek <jakub@redhat.com> 2.96-94
  - don't run texconfig in texinfo configure - it can get stuck if
    tetex is installed but tetex-xdvi is not.

* Wed Jul 11 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.96-ipl14mdk
- Sync with RH (rh-release 93: 2 patches added, 1 patch removed).

* Fri Jun 22 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.96-ipl13mdk
- More 15 patches from RH (rh-release 88).

* Thu May 24 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.96-ipl12mdk
- More patches from RH (rh-release 85).
- Fixed requires.

* Mon May 07 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.96-ipl11mdk
- More patches from RH (rh-release 84).
- Updated vendor information.

* Sat Apr 28 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.96-ipl10mdk
- More patches from RH (rh-release 81).

* Wed Apr 11 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.96-ipl9mdk
- More patches from RH (rh-release 80).

* Tue Mar 13 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.96-ipl8mdk
- Fixed update-alternatives entry for %_bindir/cpp.
- Built for release.

* Mon Jan 15 2001 Dmitry V. Levin <ldv@fandra.org> 2.96-ipl7mdk
- More patches from RH (rh-release 70).

* Fri Dec 22 2000 Dmitry V. Levin <ldv@fandra.org> 2.96-ipl6mdk
- More patches from RH (rh-release 69).
- Forced strip_method to "executable" only.
- By default do not wrap lines when printing diagnostic messages.

* Fri Dec 15 2000 Dmitry V. Levin <ldv@fandra.org> 2.96-ipl5mdk
- More patches from RH.
- Included /lib/cpp (softlink to %_bindir/cpp) into cpp subpackage.
- Added %%triggerpostun sections with update-alternatives.
- Fixed texinfo documentation.

* Tue Nov 14 2000 Dmitry V. Levin <ldv@fandra.org> 2.96-ipl4mdk
- More patches from RH.

* Tue Oct 31 2000 Dmitry V. Levin <ldv@fandra.org> 2.96-ipl3mdk
- More patches from RH.

* Sat Oct 28 2000 Dmitry V. Levin <ldv@fandra.org> 2.96-ipl2mdk
- Added few tens of patches (mainly RH, also Debian and mine).

* Sat Sep 30 2000 Dmitry V. Levin <ldv@fandra.org> 2.96-ipl1mdk
- 2.96 (RH-based), 2.95.3 moved to compat with outstanding source.

* Fri Sep 22 2000 Dmitry V. Levin <ldv@fandra.org> 2.95.3-ipl1mdk
- Initial revision (MDK-based).
- Moved colorgcc and common files/dirs into outstanding packages.
- Attempt to support using of several versions simultaneously installed.
- Fixed interface with new libio (glibc >= 2.1.90).
- Added glibc detection code to support incompatible libio API changes.
